rawset(_G.krework.chars.sonic, "preFrame", function(player)
	if player.powers[pw_super]
		and not (krework.superpowers(player))
		player.charability = CA_THOK
		return
	else
		player.charability = CA_NONE
	end
	
	local mo = player.mo
	
	mo.krework.sonic.charging = false
end)

addHook("SpinSpecial", function(player)
	-- Have to exist to uncurl
	if not (
		krework.checkExistence(player)
		and player.playerstate == PST_LIVE
		and player.mo.skin == "sonic"
	)
		return false
	end
	
	local mo = player.mo
	
	-- Check conditions for charging dropdash
	-- Have to be off the ground to charge
	if not P_IsObjectOnGround(player.mo)
	-- Have to be in a jumping state to charge
	and (player.pflags & PF_JUMPED)
	-- Have to have control to charge
	and not krework.checkNoControl(player)
	-- Dropdash has to start with a button press, not a hold
	and (not (player.pflags & PF_USEDOWN) or mo.krework.sonic.dropcharge > 0)
	-- Can't dropdash if you're Super Sonic and your ability changes are turned off
	and not (player.powers[pw_super] and not krework.superpowers(player))
		A_KRChargeDropDash(player)
	end
end)

addHook("AbilitySpecial", A_KRSonicDoubleJump)

rawset(_G.krework.chars.sonic, "playerThink", function(player)
	local mo = player.mo
	
	-- Release drop dash if you hit the ground while charged
	if mo.eflags & MFE_JUSTHITFLOOR
	and mo.krework.sonic.dropcharge > 0
	and not (mo.eflags & MFE_SPRUNG)
		A_KRReleaseDropDash(player)
	end
	
	-- If charge conditions aren't met, discharge the dropdash
	if not mo.krework.sonic.charging
		mo.krework.sonic.dropcharge = 0
		if mo.state == S_DROPDASH
			mo.state = S_PLAY_JUMP
		end
	end
	
	-- Dust trail to show Sonic's double-jump isn't available
	if player.krework.jumpused
		A_KRSonicDJDust(mo)
	end
end)
